commit ba05f7dc249b2e7d4ab569de33a5b02e16d0b35e
Author: Tomáš Šimandl <tomas.simandl@gmail.com>
Date:   Wed Aug 8 15:45:05 2018 +0200

    Modified backend to accept graph and configuration in json format instead of jar files + added filters

diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..8ed6163
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,3 @@
+sources/.idea/
+sources/build/
+sources/WebContent/node_modules/
diff --git a/sources/src/cz/zcu/kiv/offscreen/AttributeType.java b/sources/src/cz/zcu/kiv/offscreen/AttributeType.java
new file mode 100644
index 0000000..f1ca20f
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/AttributeType.java
@@ -0,0 +1,23 @@
+package cz.zcu.kiv.offscreen;
+
+import cz.zcu.kiv.offscreen.graph.GraphManager;
+
+public class AttributeType {
+    public String name;
+    public GraphManager.AttributeDataType dataType;
+    public String text;
+
+    public AttributeType(String name, GraphManager.AttributeDataType dataType, String text) {
+        this.name = name;
+        this.dataType = dataType;
+        this.text = text;
+    }
+
+    public String getName() {
+        return name;
+    }
+
+    public GraphManager.AttributeDataType getDataType() {
+        return dataType;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/EdgeInterface.java b/sources/src/cz/zcu/kiv/offscreen/api/EdgeInterface.java
index 93e5d94..c29862e 100644
--- a/sources/src/cz/zcu/kiv/offscreen/api/EdgeInterface.java
+++ b/sources/src/cz/zcu/kiv/offscreen/api/EdgeInterface.java
@@ -4,6 +4,10 @@
  */
 package cz.zcu.kiv.offscreen.api;
 
+import cz.zcu.kiv.offscreen.graph.SubedgeInfo;
+
+import java.util.List;
+
 /**
  *
  * @author Jindra Pavlíková <jindra.pav2@seznam.cz>
@@ -15,4 +19,8 @@ public interface EdgeInterface {
     public String getTo();
 
     public int getId();
+
+    public List<SubedgeInfo> getSubedgeInfo();
+
+    public void setSubedgeInfo(List<SubedgeInfo> subedgeInfo);
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/GraphInterface.java b/sources/src/cz/zcu/kiv/offscreen/api/GraphInterface.java
index 1464552..c00c77d 100644
--- a/sources/src/cz/zcu/kiv/offscreen/api/GraphInterface.java
+++ b/sources/src/cz/zcu/kiv/offscreen/api/GraphInterface.java
@@ -4,6 +4,10 @@
  */
 package cz.zcu.kiv.offscreen.api;
 
+import cz.zcu.kiv.offscreen.AttributeType;
+import cz.zcu.kiv.offscreen.graph.EdgeArchetype;
+import cz.zcu.kiv.offscreen.graph.VertexArchetype;
+
 import java.util.List;
 import java.util.Map;
 
@@ -17,5 +21,16 @@ public interface GraphInterface {
     public void addVertex(String name, VertexInterface vertex);
     public Map<String, VertexInterface> getVertices();
     public List<EdgeInterface> getEdges();
-    
+    public List<VertexArchetype>  getVertexArchetypes();
+    public List<EdgeArchetype> getEdgeArchetypes();
+    public void setVertexArchetypes(List<VertexArchetype> vertexArchetypes);
+    public void setEdgeArchetypes(List<EdgeArchetype> edgeArchetypes);
+    public void setAttributeTypes(List<AttributeType> attributeTypes);
+    public void setPossibleEnumValues(Map<Integer, List<String>> possibleEnumValues);
+    public List<AttributeType> getAttributeTypes();
+    public Map<String, List<String>> getPossibleEnumValues();
+    void setArchetypeIcons(Map<String, String> archetypeIcons);
+    Map<String, String> getArchetypeIcons();
+    List<Integer> getDefaultGroupArchetypes();
+    void setDefaultGroupArchetypes(List<Integer> defaultGroupArchetypes);
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/api/VertexInterface.java b/sources/src/cz/zcu/kiv/offscreen/api/VertexInterface.java
index ccaeea1..1254e68 100644
--- a/sources/src/cz/zcu/kiv/offscreen/api/VertexInterface.java
+++ b/sources/src/cz/zcu/kiv/offscreen/api/VertexInterface.java
@@ -26,4 +26,11 @@ public interface VertexInterface {
 
 	public void setImportedPackages(List<String> importedPackages);
 
+	public int getArchetype();
+
+	public void setArchetype(int archetype);
+
+	public void setAttributes(List<String[]> attributes);
+
+	public List<String[]> getAttributes();
 }
diff --git a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexData.java b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexData.java
index 9954476..ffe04e8 100644
--- a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexData.java
+++ b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexData.java
@@ -1,46 +1,46 @@
-/**
- * 
- */
-package cz.zcu.kiv.offscreen.data.efpportal;
-
-import java.util.HashMap;
-import java.util.Map;
-
-/**
- * 
- * Representation of EFPPortal's connections . A connection consists of a provided and required features.
- * 
- * @author Jiri Loudil
- *
- */
-public class CocaexData {
-	/**
-	 * Map of all provided features.
-	 */
-	private Map<String, CocaexDataFeature> providedFeatures;
-	
-	/**
-	 * Map of all required features.
-	 */
-	private Map<String, CocaexDataFeature> requiredFeatures;
-	
-	public CocaexData() {
-		this.providedFeatures = new HashMap<String, CocaexDataFeature>();
-		this.requiredFeatures = new HashMap<String, CocaexDataFeature>();
-	}
-
-	/**
-	 * @return the providedFeatures
-	 */
-	public Map<String, CocaexDataFeature> getProvidedFeatures() {
-		return providedFeatures;
-	}
-
-	/**
-	 * @return the importedFeatures
-	 */
-	public Map<String, CocaexDataFeature> getRequiredFeatures() {
-		return requiredFeatures;
-	}
-
-}
+///**
+// *
+// */
+//package cz.zcu.kiv.offscreen.data.efpportal;
+//
+//import java.util.HashMap;
+//import java.util.Map;
+//
+///**
+// *
+// * Representation of EFPPortal's connections . A connection consists of a provided and required features.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class CocaexData {
+//	/**
+//	 * Map of all provided features.
+//	 */
+//	private Map<String, CocaexDataFeature> providedFeatures;
+//
+//	/**
+//	 * Map of all required features.
+//	 */
+//	private Map<String, CocaexDataFeature> requiredFeatures;
+//
+//	public CocaexData() {
+//		this.providedFeatures = new HashMap<String, CocaexDataFeature>();
+//		this.requiredFeatures = new HashMap<String, CocaexDataFeature>();
+//	}
+//
+//	/**
+//	 * @return the providedFeatures
+//	 */
+//	public Map<String, CocaexDataFeature> getProvidedFeatures() {
+//		return providedFeatures;
+//	}
+//
+//	/**
+//	 * @return the importedFeatures
+//	 */
+//	public Map<String, CocaexDataFeature> getRequiredFeatures() {
+//		return requiredFeatures;
+//	}
+//
+//}
diff --git a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataEfp.java b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataEfp.java
index 1fc448a..80f677f 100644
--- a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataEfp.java
+++ b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataEfp.java
@@ -1,69 +1,69 @@
-package cz.zcu.kiv.offscreen.data.efpportal;
-
-import cz.zcu.kiv.efps.comparator.result.EfpEvalResult.MatchingResult;
-import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
-
-/**
- * Holds EFP's data.
- * 
- * @author Jiri Loudil
- *
- */
-public class CocaexDataEfp {
-	private String efpName;
-	private String efpValueTypeName;
-	private EfpValueType efpValue;
-	private MatchingResult typeError;
-	
-	/**
-	 * @return the efpName
-	 */
-	public String getEfpName() {
-		return efpName;
-	}
-	/**
-	 * @param efpName the efpName to set
-	 */
-	public void setEfpName(String efpName) {
-		this.efpName = efpName;
-	}
-	/**
-	 * @return the efpValueTypeName
-	 */
-	public String getEfpValueTypeName() {
-		return efpValueTypeName;
-	}
-	/**
-	 * @param efpValueTypeName the efpValueTypeName to set
-	 */
-	public void setEfpValueTypeName(String efpValueTypeName) {
-		this.efpValueTypeName = efpValueTypeName;
-	}
-	/**
-	 * @return the efpValue
-	 */
-	public EfpValueType getEfpValue() {
-		return efpValue;
-	}
-	/**
-	 * @param efpValue the efpValue to set
-	 */
-	public void setEfpValue(EfpValueType efpValue) {
-		this.efpValue = efpValue;
-	}
-
-	/**
-	 * @return the typeError
-	 */
-	public MatchingResult getTypeError() {
-		return typeError;
-	}
-
-	/**
-	 * @param typeError the typeError to set
-	 */
-	public void setTypeError(MatchingResult typeError) {
-		this.typeError = typeError;
-	}
-	
-}
\ No newline at end of file
+//package cz.zcu.kiv.offscreen.data.efpportal;
+//
+//import cz.zcu.kiv.efps.comparator.result.EfpEvalResult.MatchingResult;
+//import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
+//
+///**
+// * Holds EFP's data.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class CocaexDataEfp {
+//	private String efpName;
+//	private String efpValueTypeName;
+//	private EfpValueType efpValue;
+//	private MatchingResult typeError;
+//
+//	/**
+//	 * @return the efpName
+//	 */
+//	public String getEfpName() {
+//		return efpName;
+//	}
+//	/**
+//	 * @param efpName the efpName to set
+//	 */
+//	public void setEfpName(String efpName) {
+//		this.efpName = efpName;
+//	}
+//	/**
+//	 * @return the efpValueTypeName
+//	 */
+//	public String getEfpValueTypeName() {
+//		return efpValueTypeName;
+//	}
+//	/**
+//	 * @param efpValueTypeName the efpValueTypeName to set
+//	 */
+//	public void setEfpValueTypeName(String efpValueTypeName) {
+//		this.efpValueTypeName = efpValueTypeName;
+//	}
+//	/**
+//	 * @return the efpValue
+//	 */
+//	public EfpValueType getEfpValue() {
+//		return efpValue;
+//	}
+//	/**
+//	 * @param efpValue the efpValue to set
+//	 */
+//	public void setEfpValue(EfpValueType efpValue) {
+//		this.efpValue = efpValue;
+//	}
+//
+//	/**
+//	 * @return the typeError
+//	 */
+//	public MatchingResult getTypeError() {
+//		return typeError;
+//	}
+//
+//	/**
+//	 * @param typeError the typeError to set
+//	 */
+//	public void setTypeError(MatchingResult typeError) {
+//		this.typeError = typeError;
+//	}
+//
+//}
\ No newline at end of file
diff --git a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataFeature.java b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataFeature.java
index 37fdd66..d3870c2 100644
--- a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataFeature.java
+++ b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexDataFeature.java
@@ -1,33 +1,33 @@
-package cz.zcu.kiv.offscreen.data.efpportal;
-
-import java.util.ArrayList;
-import java.util.List;
-
-/**
- * Holds feature's data.
- * 
- * @author Jiri Loudil
- *
- */
-public class CocaexDataFeature {
-	private List<CocaexDataEfp> efps;
-
-	public CocaexDataFeature() {
-		this.efps = new ArrayList<CocaexDataEfp>();
-	}
-
-	/**
-	 * @return the efps
-	 */
-	public List<CocaexDataEfp> getEfps() {
-		return efps;
-	}
-
-	/**
-	 * @param efps the efps to set
-	 */
-	public void setEfps(List<CocaexDataEfp> efps) {
-		this.efps = efps;
-	}
-
-}
\ No newline at end of file
+//package cz.zcu.kiv.offscreen.data.efpportal;
+//
+//import java.util.ArrayList;
+//import java.util.List;
+//
+///**
+// * Holds feature's data.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class CocaexDataFeature {
+//	private List<CocaexDataEfp> efps;
+//
+//	public CocaexDataFeature() {
+//		this.efps = new ArrayList<CocaexDataEfp>();
+//	}
+//
+//	/**
+//	 * @return the efps
+//	 */
+//	public List<CocaexDataEfp> getEfps() {
+//		return efps;
+//	}
+//
+//	/**
+//	 * @param efps the efps to set
+//	 */
+//	public void setEfps(List<CocaexDataEfp> efps) {
+//		this.efps = efps;
+//	}
+//
+//}
\ No newline at end of file
diff --git a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexWrapper.java b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexWrapper.java
index 70ff5db..32fdd62 100644
--- a/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexWrapper.java
+++ b/sources/src/cz/zcu/kiv/offscreen/data/efpportal/CocaexWrapper.java
@@ -1,66 +1,66 @@
-package cz.zcu.kiv.offscreen.data.efpportal;
-
-import java.util.Map;
-
-/**
- * 
- * EFPPortal export data wrapper. Contains mappings for feature connection names and EFPs names.
- * 
- * @author Jiri Loudil
- *
- */
-public class CocaexWrapper {
-	/**
-	 * Feature names mapping.
-	 */
-	private Map<String, String> featureMappings;
-	
-	/**
-	 * EFPs name s mapping.
-	 */
-	private Map<String, String> efpMappings;
-	
-	/**
-	 * EFPPortal data with IDs instead of names for EFPs and Features.
-	 */
-	private Map<String, CocaexData> data;
-	
-	/**
-	 * @return the featureMappings
-	 */
-	public Map<String, String> getFeatureMappings() {
-		return featureMappings;
-	}
-	/**
-	 * @param featureMappings the featureMappings to set
-	 */
-	public void setFeatureMappings(Map<String, String> featureMappings) {
-		this.featureMappings = featureMappings;
-	}
-	/**
-	 * @return the efpMappings
-	 */
-	public Map<String, String> getEfpMappings() {
-		return efpMappings;
-	}
-	/**
-	 * @param efpMappings the efpMappings to set
-	 */
-	public void setEfpMappings(Map<String, String> efpMappings) {
-		this.efpMappings = efpMappings;
-	}
-	/**
-	 * @return the data
-	 */
-	public Map<String, CocaexData> getData() {
-		return data;
-	}
-	/**
-	 * @param data the data to set
-	 */
-	public void setData(Map<String, CocaexData> data) {
-		this.data = data;
-	}
-	
-	
-}
+//package cz.zcu.kiv.offscreen.data.efpportal;
+//
+//import java.util.Map;
+//
+///**
+// *
+// * EFPPortal export data wrapper. Contains mappings for feature connection names and EFPs names.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class CocaexWrapper {
+//	/**
+//	 * Feature names mapping.
+//	 */
+//	private Map<String, String> featureMappings;
+//
+//	/**
+//	 * EFPs name s mapping.
+//	 */
+//	private Map<String, String> efpMappings;
+//
+//	/**
+//	 * EFPPortal data with IDs instead of names for EFPs and Features.
+//	 */
+//	private Map<String, CocaexData> data;
+//
+//	/**
+//	 * @return the featureMappings
+//	 */
+//	public Map<String, String> getFeatureMappings() {
+//		return featureMappings;
+//	}
+//	/**
+//	 * @param featureMappings the featureMappings to set
+//	 */
+//	public void setFeatureMappings(Map<String, String> featureMappings) {
+//		this.featureMappings = featureMappings;
+//	}
+//	/**
+//	 * @return the efpMappings
+//	 */
+//	public Map<String, String> getEfpMappings() {
+//		return efpMappings;
+//	}
+//	/**
+//	 * @param efpMappings the efpMappings to set
+//	 */
+//	public void setEfpMappings(Map<String, String> efpMappings) {
+//		this.efpMappings = efpMappings;
+//	}
+//	/**
+//	 * @return the data
+//	 */
+//	public Map<String, CocaexData> getData() {
+//		return data;
+//	}
+//	/**
+//	 * @param data the data to set
+//	 */
+//	public void setData(Map<String, CocaexData> data) {
+//		this.data = data;
+//	}
+//
+//
+//}
diff --git a/sources/src/cz/zcu/kiv/offscreen/efp/utils/JsonTransformer.java b/sources/src/cz/zcu/kiv/offscreen/efp/utils/JsonTransformer.java
index 2c0335a..1d33aac 100644
--- a/sources/src/cz/zcu/kiv/offscreen/efp/utils/JsonTransformer.java
+++ b/sources/src/cz/zcu/kiv/offscreen/efp/utils/JsonTransformer.java
@@ -1,101 +1,101 @@
-package cz.zcu.kiv.offscreen.efp.utils;
-
-import java.io.ByteArrayInputStream;
-import java.io.IOException;
-import java.util.zip.GZIPInputStream;
-
-import javax.servlet.http.HttpServletRequest;
-
-import org.apache.log4j.Logger;
-
-import net.sf.json.JSONObject;
-
-import org.apache.commons.codec.binary.Base64;
-import org.apache.commons.io.IOUtils;
-
-import com.google.gson.Gson;
-import com.google.gson.GsonBuilder;
-
-import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
-import cz.zcu.kiv.efps.types.serialisation.json.EfpValueTypeAdapter;
-import cz.zcu.kiv.offscreen.api.GraphInterface;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
-import cz.zcu.kiv.offscreen.graph.GraphExport;
-import cz.zcu.kiv.offscreen.graph.creator.EfpGraphTransfomer;
-
-/**
- * 
- * Transofma and decompress tools for incoming JSON.
- * 
- * @author Jiri Loudil
- *
- */
-public class JsonTransformer {
-	private Logger logger = Logger.getLogger(JsonTransformer.class);
-
-	/**
-	 * 
-	 * Deserialize input JSON and transform to graph JSON.
-	 * 
-	 * @param inputJSON
-	 * @param request
-	 * @return
-	 * @throws IOException
-	 */
-	public String transformInputJSONToGraphJSON(String inputJSON,
-			HttpServletRequest request) throws IOException {
-		CocaexWrapper efpResults;
-
-		GsonBuilder gsonBuilder = new GsonBuilder();
-		// JSON deserializing adapter provided for EFP type classes
-		gsonBuilder.registerTypeAdapter(EfpValueType.class,
-				new EfpValueTypeAdapter());
-		// JSON deserializing adapter for the Wrapper class
-		gsonBuilder.registerTypeAdapter(CocaexWrapper.class,
-				new WrapperDeserializer());
-		Gson gson = gsonBuilder.create();
-
-		// decode + unzip received data
-		String data = decompress(inputJSON);
-
-		// deserialize using deserializer adapters
-		efpResults = gson.fromJson(data, CocaexWrapper.class);
-
-		request.setAttribute("efpPortalEfpNames", efpResults.getEfpMappings());
-
-		// transform received data to readable graph form
-		EfpGraphTransfomer transformer = new EfpGraphTransfomer(efpResults);
-		GraphInterface graph = transformer.transform();
-		GraphExport export = new GraphExport(graph);
-
-		// transform graph to JSON
-		JSONObject o = JSONObject.fromObject(export);
-
-		return o.toString();
-	}
-
-	/**
-	 * Decode and unzip a Base64 encoded GZIPed string.
-	 * 
-	 * @param input
-	 * @return
-	 * @throws IOException
-	 */
-	private String decompress(String input) throws IOException {
-		logger.trace("ENTRY");
-		String result = null;
-
-		byte[] bytes = Base64.decodeBase64(input);
-		GZIPInputStream zi = null;
-		try {
-			zi = new GZIPInputStream(new ByteArrayInputStream(bytes));
-			result = IOUtils.toString(zi);
-		} finally {
-			IOUtils.closeQuietly(zi);
-		}
-		logger.trace("EXIT");
-
-		return result;
-	}
-
-}
+//package cz.zcu.kiv.offscreen.efp.utils;
+//
+//import java.io.ByteArrayInputStream;
+//import java.io.IOException;
+//import java.util.zip.GZIPInputStream;
+//
+//import javax.servlet.http.HttpServletRequest;
+//
+//import org.apache.log4j.Logger;
+//
+//import net.sf.json.JSONObject;
+//
+//import org.apache.commons.codec.binary.Base64;
+//import org.apache.commons.io.IOUtils;
+//
+//import com.google.gson.Gson;
+//import com.google.gson.GsonBuilder;
+//
+//import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
+//import cz.zcu.kiv.efps.types.serialisation.json.EfpValueTypeAdapter;
+//import cz.zcu.kiv.offscreen.api.GraphInterface;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
+//import cz.zcu.kiv.offscreen.graph.GraphExport;
+//import cz.zcu.kiv.offscreen.graph.creator.EfpGraphTransfomer;
+//
+///**
+// *
+// * Transofma and decompress tools for incoming JSON.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class JsonTransformer {
+//	private Logger logger = Logger.getLogger(JsonTransformer.class);
+//
+//	/**
+//	 *
+//	 * Deserialize input JSON and transform to graph JSON.
+//	 *
+//	 * @param inputJSON
+//	 * @param request
+//	 * @return
+//	 * @throws IOException
+//	 */
+//	public String transformInputJSONToGraphJSON(String inputJSON,
+//			HttpServletRequest request) throws IOException {
+//		CocaexWrapper efpResults;
+//
+//		GsonBuilder gsonBuilder = new GsonBuilder();
+//		// JSON deserializing adapter provided for EFP type classes
+//		gsonBuilder.registerTypeAdapter(EfpValueType.class,
+//				new EfpValueTypeAdapter());
+//		// JSON deserializing adapter for the Wrapper class
+//		gsonBuilder.registerTypeAdapter(CocaexWrapper.class,
+//				new WrapperDeserializer());
+//		Gson gson = gsonBuilder.create();
+//
+//		// decode + unzip received data
+//		String data = decompress(inputJSON);
+//
+//		// deserialize using deserializer adapters
+//		efpResults = gson.fromJson(data, CocaexWrapper.class);
+//
+//		request.setAttribute("efpPortalEfpNames", efpResults.getEfpMappings());
+//
+//		// transform received data to readable graph form
+//		EfpGraphTransfomer transformer = new EfpGraphTransfomer(efpResults);
+//		GraphInterface graph = transformer.transform();
+//		GraphExport export = new GraphExport(graph);
+//
+//		// transform graph to JSON
+//		JSONObject o = JSONObject.fromObject(export);
+//
+//		return o.toString();
+//	}
+//
+//	/**
+//	 * Decode and unzip a Base64 encoded GZIPed string.
+//	 *
+//	 * @param input
+//	 * @return
+//	 * @throws IOException
+//	 */
+//	private String decompress(String input) throws IOException {
+//		logger.trace("ENTRY");
+//		String result = null;
+//
+//		byte[] bytes = Base64.decodeBase64(input);
+//		GZIPInputStream zi = null;
+//		try {
+//			zi = new GZIPInputStream(new ByteArrayInputStream(bytes));
+//			result = IOUtils.toString(zi);
+//		} finally {
+//			IOUtils.closeQuietly(zi);
+//		}
+//		logger.trace("EXIT");
+//
+//		return result;
+//	}
+//
+//}
diff --git a/sources/src/cz/zcu/kiv/offscreen/efp/utils/WrapperDeserializer.java b/sources/src/cz/zcu/kiv/offscreen/efp/utils/WrapperDeserializer.java
index f9337de..fcff7f7 100644
--- a/sources/src/cz/zcu/kiv/offscreen/efp/utils/WrapperDeserializer.java
+++ b/sources/src/cz/zcu/kiv/offscreen/efp/utils/WrapperDeserializer.java
@@ -1,76 +1,76 @@
-package cz.zcu.kiv.offscreen.efp.utils;
-
-import java.lang.reflect.Type;
-import java.util.HashMap;
-import java.util.Map;
-
-import org.apache.log4j.Logger;
-
-import com.google.gson.Gson;
-import com.google.gson.GsonBuilder;
-import com.google.gson.JsonDeserializationContext;
-import com.google.gson.JsonDeserializer;
-import com.google.gson.JsonElement;
-import com.google.gson.JsonObject;
-
-import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
-import cz.zcu.kiv.efps.types.serialisation.json.EfpValueTypeAdapter;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexData;
-import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
-
-/**
- * 
- * CocaexWrapper class deserializer.
- * 
- * @author Jiri Loudil
- * 
- */
-public class WrapperDeserializer implements JsonDeserializer<CocaexWrapper> {
-	private Logger logger = Logger.getLogger(WrapperDeserializer.class);
-
-	@Override
-	public CocaexWrapper deserialize(JsonElement json, Type typeOfT,
-			JsonDeserializationContext context) {
-		logger.trace("ENTRY");
-
-		GsonBuilder gsonBuilder = new GsonBuilder();
-		// JSON deserializing adapter provided for EFP type classes
-		gsonBuilder.registerTypeAdapter(EfpValueType.class,
-				new EfpValueTypeAdapter());
-		Gson gson = gsonBuilder.create();
-
-		CocaexWrapper wrapper = gson.fromJson(json, CocaexWrapper.class);
-		JsonObject jo = json.getAsJsonObject();
-
-		Map<String, String> featureMappings = new HashMap<String, String>();
-		Map<String, String> efpMappings = new HashMap<String, String>();
-		Map<String, CocaexData> data = new HashMap<String, CocaexData>();
-
-		// parse feature mappings
-		JsonObject featuresObject = jo.getAsJsonObject("featureMappings");
-		for (Map.Entry<String, JsonElement> entry : featuresObject.entrySet()) {
-			featureMappings.put(entry.getKey(), entry.getValue().getAsString());
-		}
-
-		// parse efps mappings
-		JsonObject efpsObject = jo.getAsJsonObject("efpMappings");
-		for (Map.Entry<String, JsonElement> entry : efpsObject.entrySet()) {
-			efpMappings.put(entry.getKey(), entry.getValue().getAsString());
-		}
-
-		// parse data
-		JsonObject dataObject = jo.getAsJsonObject("data");
-		for (Map.Entry<String, JsonElement> entry : dataObject.entrySet()) {
-			data.put(entry.getKey(), (CocaexData) context.deserialize(
-					entry.getValue(), CocaexData.class));
-		}
-
-		// fill output structure
-		wrapper.setFeatureMappings(featureMappings);
-		wrapper.setEfpMappings(efpMappings);
-		wrapper.setData(data);
-		logger.trace("EXIT");
-
-		return wrapper;
-	}
-}
+//package cz.zcu.kiv.offscreen.efp.utils;
+//
+//import java.lang.reflect.Type;
+//import java.util.HashMap;
+//import java.util.Map;
+//
+//import org.apache.log4j.Logger;
+//
+//import com.google.gson.Gson;
+//import com.google.gson.GsonBuilder;
+//import com.google.gson.JsonDeserializationContext;
+//import com.google.gson.JsonDeserializer;
+//import com.google.gson.JsonElement;
+//import com.google.gson.JsonObject;
+//
+//import cz.zcu.kiv.efps.types.datatypes.EfpValueType;
+//import cz.zcu.kiv.efps.types.serialisation.json.EfpValueTypeAdapter;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexData;
+//import cz.zcu.kiv.offscreen.data.efpportal.CocaexWrapper;
+//
+///**
+// *
+// * CocaexWrapper class deserializer.
+// *
+// * @author Jiri Loudil
+// *
+// */
+//public class WrapperDeserializer implements JsonDeserializer<CocaexWrapper> {
+//	private Logger logger = Logger.getLogger(WrapperDeserializer.class);
+//
+//	@Override
+//	public CocaexWrapper deserialize(JsonElement json, Type typeOfT,
+//			JsonDeserializationContext context) {
+//		logger.trace("ENTRY");
+//
+//		GsonBuilder gsonBuilder = new GsonBuilder();
+//		// JSON deserializing adapter provided for EFP type classes
+//		gsonBuilder.registerTypeAdapter(EfpValueType.class,
+//				new EfpValueTypeAdapter());
+//		Gson gson = gsonBuilder.create();
+//
+//		CocaexWrapper wrapper = gson.fromJson(json, CocaexWrapper.class);
+//		JsonObject jo = json.getAsJsonObject();
+//
+//		Map<String, String> featureMappings = new HashMap<String, String>();
+//		Map<String, String> efpMappings = new HashMap<String, String>();
+//		Map<String, CocaexData> data = new HashMap<String, CocaexData>();
+//
+//		// parse feature mappings
+//		JsonObject featuresObject = jo.getAsJsonObject("featureMappings");
+//		for (Map.Entry<String, JsonElement> entry : featuresObject.entrySet()) {
+//			featureMappings.put(entry.getKey(), entry.getValue().getAsString());
+//		}
+//
+//		// parse efps mappings
+//		JsonObject efpsObject = jo.getAsJsonObject("efpMappings");
+//		for (Map.Entry<String, JsonElement> entry : efpsObject.entrySet()) {
+//			efpMappings.put(entry.getKey(), entry.getValue().getAsString());
+//		}
+//
+//		// parse data
+//		JsonObject dataObject = jo.getAsJsonObject("data");
+//		for (Map.Entry<String, JsonElement> entry : dataObject.entrySet()) {
+//			data.put(entry.getKey(), (CocaexData) context.deserialize(
+//					entry.getValue(), CocaexData.class));
+//		}
+//
+//		// fill output structure
+//		wrapper.setFeatureMappings(featureMappings);
+//		wrapper.setEfpMappings(efpMappings);
+//		wrapper.setData(data);
+//		logger.trace("EXIT");
+//
+//		return wrapper;
+//	}
+//}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java b/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java
new file mode 100644
index 0000000..2a1ddd6
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/Attribute.java
@@ -0,0 +1,11 @@
+package cz.zcu.kiv.offscreen.graph;
+
+public class Attribute {
+    int typeIndex;
+    Object value;
+
+    public Attribute(int typeIndex, Object value) {
+        this.typeIndex = typeIndex;
+        this.value = value;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java
new file mode 100644
index 0000000..28c8519
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetype.java
@@ -0,0 +1,15 @@
+package cz.zcu.kiv.offscreen.graph;
+
+public class EdgeArchetype {
+    public String name;
+    public String text;
+
+    EdgeArchetype(String name, String text) {
+        this.name = name;
+        this.text = text;
+    }
+
+    public String getName() {
+        return  name;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetypeInfo.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetypeInfo.java
new file mode 100644
index 0000000..d61acfc
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeArchetypeInfo.java
@@ -0,0 +1,35 @@
+package cz.zcu.kiv.offscreen.graph;
+
+public class EdgeArchetypeInfo {
+    /**
+     * index of the archetype of the vertex the edge leads to
+     */
+    public int fromArchetypeIndex;
+
+    /**
+     * index of the archetype of the edge
+     */
+    public int edgeArchetypeIndex;
+
+    /**
+     * index of the archetype of the vertex the edge leads from
+     */
+    public int toArchetypeIndex;
+
+    public EdgeArchetypeInfo(int fromArchetypeIndex, int edgeArchetypeIndex, int toArchetypeIndex) {
+        this.fromArchetypeIndex = fromArchetypeIndex;
+        this.edgeArchetypeIndex = edgeArchetypeIndex;
+        this.toArchetypeIndex = toArchetypeIndex;
+    }
+
+    @Override
+    public int hashCode() {
+        return fromArchetypeIndex * 10000 + edgeArchetypeIndex * 100 + fromArchetypeIndex;
+    }
+
+    @Override
+    public boolean equals(Object obj) {
+        EdgeArchetypeInfo info = (EdgeArchetypeInfo)obj;
+        return (info.fromArchetypeIndex == fromArchetypeIndex) && (info.edgeArchetypeIndex == edgeArchetypeIndex) && (info.toArchetypeIndex == toArchetypeIndex);
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeData.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeData.java
new file mode 100644
index 0000000..2e229d3
--- /dev/null
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeData.java
@@ -0,0 +1,54 @@
+package cz.zcu.kiv.offscreen.graph;
+
+import java.util.*;
+
+public class EdgeData {
+    public int id;
+    public int from;
+    public int to;
+    public String text;
+    public int archetypeIndex;
+    public Map<Integer, Attribute> attributes = new HashMap<>();
+
+    public EdgeData(int id, int from, int to, String text, int archetypeIndex) {
+        this.id = id;
+        this.from = from;
+        this.to = to;
+        this.text = text;
+        this.archetypeIndex = archetypeIndex;
+    }
+
+    public void addAttribute(int attrTypeIndex, Object value) {
+        Attribute attr = new Attribute(attrTypeIndex, value);
+        attributes.put(attrTypeIndex, attr);
+    }
+
+    public void addAttributes(Map<Integer, Attribute> attributes) {
+        this.attributes.putAll(attributes);
+    }
+
+    public Attribute getAttribute(int attrTypeIndex) {
+        return attributes.get(attrTypeIndex);
+    }
+
+    @Override
+    public int hashCode() {
+        return from * 100000 + to;
+    }
+
+    @Override
+    public boolean equals(Object edge) {
+        return from == ((EdgeData) edge).from && to == ((EdgeData) edge).to;
+    }
+
+    public List<Attribute> getSortedAttributes() {
+        List<Attribute> list = new ArrayList<>();
+        ArrayList<Integer> indices = new ArrayList<>(attributes.keySet());
+        //indices.sort(Integer::compareTo);
+        Collections.sort(indices); // TODO check correct order
+        for (int i = 0; i < indices.size(); i++) {
+            list.add(attributes.get(indices.get(i)));
+        }
+        return list;
+    }
+}
diff --git a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeEfp.java b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeEfp.java
index fe0eab5..21b1de8 100644
--- a/sources/src/cz/zcu/kiv/offscreen/graph/EdgeEfp.java
+++ b/sources/src/cz/zcu/kiv/offscreen/graph/EdgeEfp.java
@@ -1,6 +1,7 @@
 package cz.zcu.kiv.offscreen.graph;
 
 import java.util.ArrayList;
+import java.util.List;
 
 import org.apache.log4j.Logger;
 
@@ -65,6 +66,16 @@ public class EdgeEfp implements EdgeInterface {
 		return edgeId;
 	}
 
+	@Override
+	public List<SubedgeInfo> getSubedgeInfo() {
+		return null;
+	}
+
+	@Override
+	public void setSubedgeInfo(List<SubedgeInfo> subedgeInfo) {
+		// TODO 30.7.2018 empty body (copy from CoCaEx ASWI)
+	}
+
 	public ArrayList<EfpFeature> getFeatures() {
 		return features;
 	}
